let checkRepo = require('./checkRepo');
let getRepoPath = require('./getRepoPath');
let nodepath = require('path');
let chalk = require('chalk');
const spawn = require('cross-spawn');
const fs = require('fs-extra');
let utils=require('./utils');
let cwd=process.cwd();
let mount=require('./mount');

let preHandle = (appOption) => {
  let {appName,npm}=appOption;
  return new Promise((resolve, reject) => {
    checkRepo
      .npm(appOption)
      .then(info => {
        let latest = info.latest;
        try {
          spawn.sync(npm, ['i', `${appName}@${latest}`, '-S'], {
            stdio: 'inherit',
            cwd: nodepath.join(__dirname, '../')
          });
          resolve();
        } catch (e) {
          console.log(e);
          resolve();
        }
      })
      .catch(e => {
        console.log(e);
        resolve();
      });
  });
};



let copy = (appOption, projectName, option) => {
  let { nowrap = false, dist = '' } = option;
  if(!projectName && !nowrap){
    utils.print(
      `appName is not point,you need point just like 'zoom-create-bot create lti'`
    );
    process.exit(1);
  }
  
  projectName=projectName||'app';
  console.log('waiting...');
  let src = getRepoPath(appOption);
  let src1 = nodepath.join(src, 'resource','lambda', 'package');
  let src2 = nodepath.join(src, 'resource','static', 'package');

  try {
    fs.statSync(src);
  } catch (e) {


  }

  dist = nowrap
  ? nodepath.join(cwd, dist)
  : nodepath.join(cwd, dist, projectName);

  return new Promise((resolve, reject) => {
    preHandle(appOption)
      .then(() => {
        fs.copySync(src1, dist);
        fs.copySync(src2,nodepath.join(dist,'static'));

        mount.copy(dist,projectName,appOption).then(()=>{
          utils.print(`create ${projectName} ${dist} success,and this is for serverless lambda application`);
          resolve();
        })
        .catch((e)=>{
          console.log(e);
          reject(e);
        });

      })
      .catch(e => {
        console.log(e);
        reject(e);
      });
  });
};



let list = (appOption) => {
  return new Promise((resolve, reject) => {
    let src = getRepoPath(appOption);

    src = nodepath.join(src, 'resource');
    try {
      let list = fs.readdirSync(src);
      console.log(chalk.green('拥有的模版为：' + list.join(',')));
      resolve;
    } catch (e) {
      console.log(e);
      reject();
    }

    // resolve();
  });
};

module.exports = {
  copy,
  list
};
