const spawn = require('cross-spawn');
const jsonFormat = require('json-format');
let nodepath=require('path');
const fs = require('fs-extra');
let utils=require('./utils');


let copy=(dist,projectName,appOption)=>{
    let {npm}=appOption;
    return new Promise((resolve,reject)=>{
        try{
        let packagePath=nodepath.join(dist, 'package.json');
        let packageObject = fs.readJsonSync(packagePath);
        packageObject.name = projectName;
        fs.writeFileSync(packagePath,jsonFormat(packageObject),'utf8');

        let localObject = fs.readJsonSync(
            nodepath.join(dist, 'serverless.local.json')
          );
        let devObject = fs.readJsonSync(
        nodepath.join(dist, 'serverless.dev.json')
        );
        let prodObject = fs.readJsonSync(
        nodepath.join(dist, 'serverless.prod.json')
        );

        [localObject, devObject, prodObject].forEach(obj => {
            obj.app = projectName;
            obj.environment.app = projectName;
        });

        fs.writeFileSync(
            nodepath.join(dist, 'serverless.local.json'),
            jsonFormat(localObject),
            'utf8'
          );
          
          fs.writeFileSync(
            nodepath.join(dist, 'serverless.dev.json'),
            jsonFormat(devObject),
            'utf8'
          );

          fs.writeFileSync(
            nodepath.join(dist, 'serverless.prod.json'),
            jsonFormat(prodObject),
            'utf8'
          );


      

          utils.print(`begin to install deps in ${projectName}`, 'green');


          

          spawn.sync(npm, ['i'], {
            stdio: 'inherit',
            cwd: dist
          });
          utils.print(`begin to install deps in ${projectName}/static`, 'green');
          spawn.sync(npm, ['i'], {
            stdio: 'inherit',
            cwd: nodepath.join(dist,'static')
          });

          resolve();

        }
        catch(e){
            reject(e);
        }
    });

};


module.exports={
copy

};